;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.6.0 #9615 (Linux)
;--------------------------------------------------------
	.module max7219
	.optsdcc -mstm8
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _m7219_send
	.globl _serout
	.globl _m7219_init
	.globl _m7219_col
	.globl _m7219_clrscr
	.globl _m7219_setbmp
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area HOME
	.area GSINIT
	.area GSFINAL
	.area GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area HOME
	.area HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area CODE
;	src/max7219.c: 29: void serout(uint8_t data)
;	-----------------------------------------
;	 function serout
;	-----------------------------------------
_serout:
	sub	sp, #6
;	src/max7219.c: 33: for(i= 8; i> 0; i--)
	ld	a, #0x08
	ld	(0x02, sp), a
00105$:
;	src/max7219.c: 35: val = (data & (1 << (i-1)) ) >> (i - 1);
	clrw	x
	ld	a, (0x02, sp)
	ld	xl, a
	decw	x
	ldw	(0x03, sp), x
	ldw	x, #0x0001
	ld	a, (0x04, sp)
	jreq	00122$
00121$:
	sllw	x
	dec	a
	jrne	00121$
00122$:
	ld	a, (0x09, sp)
	ld	(0x06, sp), a
	clr	(0x05, sp)
	ld	a, xl
	and	a, (0x06, sp)
	rlwa	x
	and	a, (0x05, sp)
	ld	xh, a
	ld	a, (0x04, sp)
	jreq	00124$
00123$:
	sraw	x
	dec	a
	jrne	00123$
00124$:
	ld	a, xl
	ld	(0x01, sp), a
;	src/max7219.c: 36: m7219_clkclr();
	ldw	x, #0x500a
	ld	a, (x)
	and	a, #0xbf
	ld	(x), a
	ldw	x, #0x500a
	ld	a, (x)
;	src/max7219.c: 37: if(val)
	tnz	(0x01, sp)
	jreq	00102$
;	src/max7219.c: 38: m7219_dinset();
	or	a, #0x80
	ldw	x, #0x500a
	ld	(x), a
	jra	00103$
00102$:
;	src/max7219.c: 40: m7219_dinclr();
	and	a, #0x7f
	ldw	x, #0x500a
	ld	(x), a
00103$:
;	src/max7219.c: 41: m7219_clkset();
	ldw	x, #0x500a
	ld	a, (x)
	or	a, #0x40
	ld	(x), a
;	src/max7219.c: 33: for(i= 8; i> 0; i--)
	dec	(0x02, sp)
	tnz	(0x02, sp)
	jrne	00105$
	addw	sp, #6
	ret
;	src/max7219.c: 54: void m7219_send(uint8_t reg, uint8_t data)
;	-----------------------------------------
;	 function m7219_send
;	-----------------------------------------
_m7219_send:
;	src/max7219.c: 56: m7219_loadclr();
	ldw	x, #0x5000
	ld	a, (x)
	and	a, #0xf7
	ld	(x), a
;	src/max7219.c: 57: serout(reg);
	ld	a, (0x03, sp)
	push	a
	call	_serout
	pop	a
;	src/max7219.c: 58: serout(data);
	ld	a, (0x04, sp)
	push	a
	call	_serout
	pop	a
;	src/max7219.c: 59: m7219_loadset();
	ldw	x, #0x5000
	ld	a, (x)
	or	a, #0x08
	ld	(x), a
	ret
;	src/max7219.c: 68: void m7219_init()
;	-----------------------------------------
;	 function m7219_init
;	-----------------------------------------
_m7219_init:
;	src/max7219.c: 70: m7219_init_con();
	bset	0x500c, #7
	bset	0x500d, #7
	bres	0x500e, #7
	ldw	x, #0x500c
	ld	a, (x)
	or	a, #0x40
	ld	(x), a
	ldw	x, #0x500d
	ld	a, (x)
	or	a, #0x40
	ld	(x), a
	ldw	x, #0x500e
	ld	a, (x)
	and	a, #0xbf
	ld	(x), a
	ldw	x, #0x5002
	ld	a, (x)
	or	a, #0x08
	ld	(x), a
	ldw	x, #0x5003
	ld	a, (x)
	or	a, #0x08
	ld	(x), a
	ldw	x, #0x5004
	ld	a, (x)
	and	a, #0xf7
	ld	(x), a
;	src/max7219.c: 72: m7219_dinclr();
	bres	0x500a, #7
;	src/max7219.c: 73: m7219_clkclr();
	ldw	x, #0x500a
	ld	a, (x)
	and	a, #0xbf
	ld	(x), a
;	src/max7219.c: 74: m7219_loadclr();
	ldw	x, #0x5000
	ld	a, (x)
	and	a, #0xf7
	ld	(x), a
;	src/max7219.c: 76: m7219_send(0x0b, 0x07);   // Scanlimit
	push	#0x07
	push	#0x0b
	call	_m7219_send
	popw	x
;	src/max7219.c: 77: m7219_send(0x09, 0x00);   // LED-Matrix, keine 7 Segment
	push	#0x00
	push	#0x09
	call	_m7219_send
	popw	x
;	src/max7219.c: 78: m7219_send(0x0c, 0x01);   // Power an
	push	#0x01
	push	#0x0c
	call	_m7219_send
	popw	x
;	src/max7219.c: 79: m7219_send(0x0f, 0x00);   // kein Displaytest
	push	#0x00
	push	#0x0f
	call	_m7219_send
	popw	x
;	src/max7219.c: 80: m7219_send(0x0a, 0x02);   // Intensitaet
	push	#0x02
	push	#0x0a
	call	_m7219_send
	popw	x
;	src/max7219.c: 82: m7219_clrscr();
	jp	_m7219_clrscr
;	src/max7219.c: 95: void m7219_col(uint8_t digit, uint8_t data)
;	-----------------------------------------
;	 function m7219_col
;	-----------------------------------------
_m7219_col:
;	src/max7219.c: 97: m7219_send(digit + 1, data);
	ld	a, (0x03, sp)
	inc	a
	ld	xh, a
	ld	a, (0x04, sp)
	push	a
	ld	a, xh
	push	a
	call	_m7219_send
	popw	x
	ret
;	src/max7219.c: 105: void m7219_clrscr()
;	-----------------------------------------
;	 function m7219_clrscr
;	-----------------------------------------
_m7219_clrscr:
;	src/max7219.c: 109: for(i= 0; i< 8; i++)
	clr	a
00102$:
;	src/max7219.c: 111: m7219_col(i, 0);
	push	a
	push	#0x00
	push	a
	call	_m7219_col
	popw	x
	pop	a
;	src/max7219.c: 109: for(i= 0; i< 8; i++)
	inc	a
	cp	a, #0x08
	jrc	00102$
	ret
;	src/max7219.c: 124: void m7219_setbmp(uint8_t *bmp)
;	-----------------------------------------
;	 function m7219_setbmp
;	-----------------------------------------
_m7219_setbmp:
;	src/max7219.c: 128: for (i= 0; i< 8; i++)
	clr	a
00102$:
;	src/max7219.c: 130: m7219_col(i, bmp[i]);
	clrw	x
	ld	xl, a
	addw	x, (0x03, sp)
	push	a
	ld	a, (x)
	ld	xl, a
	pop	a
	push	a
	pushw	x
	addw	sp, #1
	push	a
	call	_m7219_col
	popw	x
	pop	a
;	src/max7219.c: 128: for (i= 0; i< 8; i++)
	inc	a
	cp	a, #0x08
	jrc	00102$
	ret
	.area CODE
	.area INITIALIZER
	.area CABS (ABS)
